 %let dir=C:\samplecode;
 %include "&dir.\glmimpcore.sas";
  %include "&dir.\probbinPXDAcore.sas";
 libname tmp1 "&dir";
*options nosource nosource2 nonotes;


%macro glm_imp (datain=raw, data_temp_out=raw_glm_imp, seed=100, ncat=2, npost=2,nxcov=3,burnin=10000, nsample=1000, nthin=20);
proc datasets nodetails; delete dataall CR deltaall miest_MAR miest_CR  miest_deltaall;run;
%MLE_initial (datain=&datain, cov=%str(y0 trt), ncat=&ncat,npost=&npost, out=initial);
%coreglm (nxcov=&nxcov, npost=&npost,ncat=&ncat, datain=raw,iniparam=initial, 
         nthin=&nthin, nburn=&burnin,nsample=&nsample,Rinv=0,  
             dataimpout=dataall, betaout=betaall,seed=&seed, colname=%str('int' 'y0' 'trt'),scheme=1,
          plotafterburn=0, nlag=100);

%logis_data_analysis (dataimpin=dataall,nsample=&nsample,
   cov=y0 trt, cov2=intercept y0 trt,  ncat=&ncat, npost=&npost, visit=LAST, resultout=miest_MAR, missing=MAR, model=GLM);

%MNAR_imputation_glm(dataimpin=dataall, dataimpout=CR,
     betain=betaall, method=CR, delta=0.2,nxcov=&nxcov, ncat=&ncat, npost=&npost,colname=%str('int' 'y0' 'trt'),
              seed=&seed);

%logis_data_analysis (dataimpin=CR,nsample=&nsample,
   cov=y0 trt, cov2=intercept y0 trt, ncat=&ncat, npost=&npost, visit=LAST, resultout=miest_CR, missing=CR, model=GLM);
  
%MNAR_imputation_glm(dataimpin=dataall, dataimpout=deltaall,
     betain=betaall, method=deltaall, delta=-0.5,nxcov=&nxcov, ncat=&ncat, npost=&npost,colname=%str('int' 'y0' 'trt'), seed=20000 );

%logis_data_analysis (dataimpin=deltaall,nsample=&nsample,
   cov=y0 trt, cov2=intercept y0 trt, ncat=&ncat, npost=&npost, visit=LAST, resultout=miest_deltaall, missing=deltaall, model=GLM);
%mend;
*** dataset for binary endpoint, 2 datapoints after randomization, pattern=0,1,2;
data raw;
set tmp1.binary_sampledata;
run;

**** imputation and analysis based on sequential logistic regression;
%glm_imp (datain=raw, data_temp_out=raw_glm_imp, seed=100, ncat=2, npost=2,nxcov=3,burnin=10000, nsample=1000, nthin=20);




/*
*****the following code is used for the imputation and analysis based on probit model for binray endpoint;

%macro probit_imp (datain=raw,seed=100, ncat=2, npost=2,nxcov=3,burnin=10000, nsample=1000, nthin=100);

%MLE_initial (datain=&datain, cov=%str(y0 trt), ncat=&ncat,npost=&npost, out=initial);

%coreprobitbin (nxcov=&nxcov, npost=&npost,ncat=&ncat, datain=raw, iniparam=initial, nthin=&nthin, nburn=&burnin,nsample=&nsample,
              Rinv=0, 
                dataimpout=dataall, betaout=betaall,seed=&seed,colname=%str('int' 'y0' 'trt'), valmax=999999999999999, maxk=1000, 
               latentscheme=3, PXDA=YES,plotafterburn=0, nlag=&nthin, nloop=3, extreme=4);

%logis_data_analysis (dataimpin=dataall,nsample=&nsample,
   cov=y0 trt, cov2=intercept y0 trt,  ncat=&ncat, npost=&npost, visit=LAST, resultout=miest_MAR, missing=MAR, model=probit);

%MNAR_imputation_probitbin(dataimpin=dataall, dataimpout=CR,
     betain=betaall, method=CR, delta=0.2,nxcov=&nxcov, ncat=&ncat,  npost=&npost,colname=%str('int' 'y0' 'trt') );

%logis_data_analysis (dataimpin=CR,nsample=&nsample,
   cov=y0 trt, cov2=intercept y0 trt, ncat=&ncat, npost=&npost, visit=LAST, resultout=miest_CR, missing=CR, model=probit);
%mend;

*** dataset for binary endpoint, 2 datapoints after randomization, pattern=0,1,2;
data raw;
set tmp1.binary_sampledata;
run;


%probit_imp (datain=raw,seed=100, ncat=2, npost=2,nxcov=3,burnin=10000, nsample=1000, nthin=100);
*/
