
%macro MLE_initial (datain=raw, cov=%str(y0 trt),ncat=4, npost=3, out=initial);

proc datasets nodetails; delete &out;run;
Ods listing close;
%do kkk=&npost %to 1 %by -1;
 PROC logistic  data=&datain;
 %if kkk=1 %then %do;
   MODEL  y&kkk =  &cov;
 %end;
 %else %do;
    MODEL  y&kkk =  &cov %do j=1 %to %eval(&kkk-1); y&j %end;;
  %end;
   ods output ParameterEstimates=par&kkk;
 RUN;

  data par&kkk;
  set par&kkk; 
  %if &ncat>2 %then %do;
  if variable='Intercept' then var='int'||left(classVal0);
  else var=variable;
  %end;
  %else %do;
  var=variable;
  %end;
  kkk=&kkk;
  run;

  proc transpose data=par&kkk out=tpar&kkk;
  id  Var;
  var estimate;
  by kkk;
  run;

  proc append base=&out data=tpar&kkk force;run;

%end;
ods listing;
 
 proc sort data=&out;by kkk;run;
 %let kk=%eval(&ncat-1);
 data &out;
 %if &ncat>2 %then %do;
   retain int2-int&kk int1 &cov y1-y&npost;
 %end;
 %else %do;
   retain intercept &cov y1-y&kk;
 %end;
 set &out;
 drop _name_ kkk;
 run;
 proc print data=&out;run;

%mend;


%macro coreglm(nxcov=2, npost=3,ncat=4, datain=raw, iniparam=initial, nthin=1, nburn=100,nsample=400,Rinv=0.00001, 
                dataimpout=dataall, betaout=betaall,seed=200,colname= ,ctune=2, scheme=1,plotafterburn=10000, nlag=100);
*** scheme=1: betatempnew ~ N( betatemp+ inv(I)*score, inv(I));
*** scheme=2: betatempnew ~ N( betatemp, inv(I));

data misstag;
retain obs totm firstm pattern;
array yy{&npost} y1-y&npost;
array tag{&npost} tag1-tag&npost;
set &datain;
obs=_N_;
totm=0;
do i=1 to pattern-1;
 if yy[i]=. then do; 
   totm=totm+1;
   tag[totm]=i;
  end;
end;
if totm>0;

firstm=tag[1];

keep obs totm firstm tag1-tag&npost pattern;
run;


proc sql noprint;
 select count(*) into :nmiss from work.misstag;
quit;
%put 'nmiss' &nmiss;



proc iml;
  use &datain;
  read all into raw;
  ntot= nrow(raw);
  pat=raw[, &nxcov+&npost+1];

  use misstag;
  read all into miss;

  call streaminit(&seed);
 call randseed(&seed*1000);
   datat=raw;
   if &nmiss>0 then do;
      use misstag;
      read all into miss;
        print 'miss' (nrow(miss));
      if nrow(miss)>0 then do;
           obs=miss[,1];
           tmiss = miss[,2];
           indexall = miss[,  3:4];
           indexmiss = miss[,4+(1:&npost)]; 
        *	 print obs tmiss indexall indexmiss;
           do i=1 to nrow(miss);
             datat[obs[i],&nxcov + indexmiss[i,1:(tmiss[i])]] = datat[obs[i],&nxcov+indexall[i,2]]; 
           end;
       end;
    end;

	*print datat;
 
	*print miss;
  npat =&npost;
  ytemp=j(&nsample,1,.);
  nmcmc=&nsample * &nthin +&nburn;
  betacut=0;
 ****set initial;
 use &iniparam;
 read all into beta; *** store (exp(theta), beta);

 nposttrt =j(&npost,1,0);
 do j=1 to &npost;
  nposttrt[j]= sum( pat>=j);
 end;

 

 betatemp =beta;   *** store (theta beta);
                 *** beta store(sum(exp(theta)), beta);
 if &ncat>2 then do;
   do j=&ncat-2 to 1 by -1;
       if j>1 then  betatemp[,j]=log(beta[,j]-beta[,j-1]);
       beta[,j]=beta[,j]-beta[,&ncat-1];
   end;
      betatemp[,1]=log(beta[,1]);
 end;

 
start probfut(betax,betacut, ncat, xtemp,ntem);
    ****for binary, betacut=0;
    ***otherwise, betacut=0,cut1,cut(k-1); 
    *** overall betacut = 0//beta[1:(&ncat-2)];

    xbeta = xtemp*betax`;  
    if &ncat>2 then xbeta = xbeta + shape((0||betacut), ntem, ncat-1);
	probtemp =1/(1+exp(-xbeta));
    return(probtemp);
finish;


 start probi(beta,resp, ini, end, mcmc,cand); 
  * print resp ini end;
   probtemp=1;
   do k=ini to end;
    sta = resp[&nxcov +k];
	xtemp = resp[1:(&nxcov+k-1)];
	if &ncat>2 then do;
    	xbeta =beta[k,&ncat-2+(1:(&nxcov+k-1))]*xtemp;
     	if sta =1 then pk = 1- 1/(1+exp(xbeta));
        else if sta=2 then pk = 1/(1+exp(xbeta)) - 1/(1+exp(beta[k,1]+ xbeta));
        else if sta<&ncat then pk = 1/(1+exp(beta[k,sta-2]+ xbeta)) - 1/(1+exp(beta[k,sta-1]+ xbeta));
        else if sta=&ncat then pk =1/(1+exp(beta[k,sta-2]+ xbeta));
	end;
	else if &ncat=2 then do;
      xbeta =beta[k,(1:(&nxcov+k-1))]*xtemp;
      if sta =1 then pk = 1/(1+exp(-xbeta));
	  else pk =  1/(1+exp(xbeta));
	end;
	probtemp= probtemp*pk;
   end;
    return(probtemp);
 finish;

 *** to generate multivariate normal variates with mean inv(A)*B, variance inv(A);
 start mnorm(B, A, seed);
     Lx = root(A);
	 df=nrow(A);
     mtemp = trisolv(2,Lx, B)+ normal(j(df,1,seed));
     varnorm =(trisolv(1,Lx,mtemp))`;
     return (varnorm);
 finish;


 start get_likelihood_mean_var(xytemp, betai,betaitemp, ncat, mcmc, cand);
    ncov =ncol(xytemp);
	nitemp = nrow(xytemp);
    covdim=ncat-2+ncov-1;
	score=j(covdim,1,0);
	Fish=j(covdim,covdim,0);
     loglik=0;
    xtemp = xytemp[,1:(ncov-1)];
	ytemp = xytemp[,ncov];   
	xbeta = xtemp *(betai[ncat-2+(1:(ncov-1))]);

    picum=j(nitemp,ncat,1);
    picum[,1] = 1- 1/(1+exp(xbeta));
	do k=2 to ncat-1;
      picum[,k] = 1 - 1/(1+exp(betai[k-1]+ xbeta));
	end;
      pitemp=picum; 
	do k=2 to ncat;
      pitemp[,k]=picum[,k]-picum[,k-1];	
	end;

  
     partgamma = j( nitemp, covdim * ncat, 0);
     xpand=xtemp;
     if ncat>2 then xpand = j(nitemp, ncat-2,0)||xpand;
     do k=1 to ncat-1;
	   if (ncat>2) & (k>1) then do;
	   *  xpand[,k-1] = j(nitemp,1,exp(betaitemp[k-1]));
          xpand[,k-1] = exp(betaitemp[k-1]);
       end;
 
	   partgamma[, covdim*(k-1)+(1:covdim)]=xpand#((picum[,k])#(1-picum[,k]));
	 end;

     partbeta=partgamma;
     do k=1 to ncat;
	  if k>1 then partbeta[, covdim*(k-1)+(1:covdim)] = 
         partgamma[, covdim*(k-1)+(1:covdim)] - partgamma[, covdim*(k-2)+(1:covdim)];
	  Fish = Fish+ (partbeta[, covdim*(k-1)+(1:covdim)] /pitemp[,k])`*(partbeta[, covdim*(k-1)+(1:covdim)]);
	 end;

	 do i=1 to nitemp;
    	 loglik= loglik + log(pitemp[i,ytemp[i]]);
		 score=score+ (partbeta[i, covdim*(ytemp[i]-1)+(1:covdim)]/pitemp[i,ytemp[i]])`;
	 end;

   return((score||Fish||j(covdim,1,loglik)));
 finish; 





  betatempnew=betatemp;
  betanew=beta;

betaall =j(&npost*&nsample,  &ncat-2+&nxcov + &npost,.);
dataall =j(ntot*&nsample,  &nxcov + &npost+3,.);
if (&plotafterburn>0) then 
   betaplot = j(&npost*&plotafterburn,  &ncat-2+&nxcov + &npost,.);
 
  accept=0;

 do mcmc=1 to nmcmc;
   
 *** update beta and theta;
  do i=1 to &npost;
   xytemp = datat[1:(nposttrt[i]),1:(&nxcov+i)];
   covdim=&ncat-2+&nxcov+i-1;

   Okok= get_likelihood_mean_var(xytemp, beta[i,],betatemp[i,], &ncat, mcmc, 0);
 
     loglik= okok[1,covdim+2];
 
     Lx = root(okok[,2:(covdim+1)]+(&rinv)#I(covdim));
	 if &scheme=1 then do;
	     m1=trisolv(2,Lx, okok[,1]);
         mtemp = m1+ normal(j(covdim,1,&seed));
    	 mean= trisolv(1,Lx,m1);
     	 move=trisolv(1,Lx,mtemp);
     end; 
     else do;
           mtemp = normal(j(covdim,1,&seed));
           move=trisolv(1,Lx,mtemp);
	 end;

     betatempnew[i,1:covdim] =betatemp[i,1:covdim]+move`;

	 if &scheme=1 then
       log_dem = -sum((betatemp[i,1:covdim])##2)#(&rinv)/2+ loglik 
            + sum(log(vecdiag(Lx))) - (mean-move)`*(Lx`*Lx)*(mean-move)/2;
      else 
       log_dem = -sum((betatemp[i,1:covdim])##2)#(&rinv)/2+ loglik + sum(log(vecdiag(Lx))) - move`*(Lx`*Lx)*move/2;

   betanew[i,]=betatempnew[i,];
   if &ncat>2 then  betanew[i,1:(&ncat-2)]=cusum(exp( betanew[i,1:(&ncat-2)]));


   Okok2= get_likelihood_mean_var(xytemp, betanew[i,],betatempnew[i,], &ncat, mcmc, 1);
    Lx2 = root(okok2[,2:(covdim+1)]+(&rinv)#I(covdim));
	if &scheme=1 then do;
      m2=trisolv(2,Lx2, okok2[,1]);
	  mean2= trisolv(1,Lx2,m2);
     log_num = -sum((betatempnew[i,1:covdim])##2)#(&rinv)/2+  okok2[1,covdim+2]
             +sum(log(vecdiag(Lx2))) - (mean2+move)`*(Lx2`*Lx2)*(mean2+move)/2;
    end;
    else 
    log_num = -sum((betatempnew[i,1:covdim])##2)#(&rinv)/2+  okok2[1,covdim+2]
          +sum(log(vecdiag(Lx2)))-move`*(Lx2`*Lx2)*move/2;
  

 *ratio=exp(log_num -log_dem);
  if log(uniform(&seed))< log_num -log_dem then do;
    accept=accept+1;
    beta[i,]=betanew[i,];
    betatemp[i,]=betatempnew[i,];
   * print  mcmc i move beta;
  end;
end;




*****update intermittent missing data;

  do i=1 to nrow(miss);
    respi = raw[obs[i], ];
	nmissi = tmiss[i];
	totpos = (&ncat)**(nmissi);
	temp_prob = j(totpos,1,.); 
	respiall =j(totpos,nmissi,.);

    do k=1 to nmissi;
	  length= (&ncat)**(nmissi-k);
      aaa= j(length,1,1) %do jjj=2 %to &ncat; //j(length,1,&jjj) %end;;
      respiall[,k]= shape(aaa, totpos,1);
    end; 
  
	do j=1 to totpos;
        respi[&nxcov + indexmiss[i,1:(tmiss[i])]]=respiall[j,];
        temp_prob[j]=probi(beta,respi, indexall[i,1], indexall[i,2], mcmc,1);
    end;
  
*    temp_prob2=cusum(temp_prob); 
*	tempuni=uniform(&seed)*temp_prob2[totpos];
*	j=(loc(temp_prob2>tempuni))[1];
    call randgen(j,'table', temp_prob/sum(temp_prob));
    respi[&nxcov + indexmiss[i,1:(tmiss[i])]]=respiall[j,];
	****imputed intermitted missing data; 
     datat[obs[i],]=respi;
  end;



  col = (mcmc -&nburn)/&nthin;
  if (&plotafterburn>0) & (mcmc> &nburn) & (mcmc<=&nburn+&plotafterburn) then do;
     ntempplot=mcmc-&nburn;
     betaplot[(ntempplot-1)*(&npost)+(1:(&npost)),]=beta||J(&npost,1,ntempplot);
  end;
 
  if (col >0) & (int(col)=col) then do;

     betaall[(col-1)*(&npost)+(1:&npost),]=beta||J(&npost,1,col); 

	
   ***** imputation of post-dropout data under MAR;
	 do s=1 to &npost;
		ntem=ntot - nposttrt[s];
	*	print mcmc s ntem;
		if ntem >0 then do;
    	    loctem =(nposttrt[s]+1):ntot;
            xtemp =datat[loctem, 1:(&nxcov+s-1)];
	     	betax = beta[s,&ncat-2 +(1:(&nxcov+s-1))];
	    	if &ncat>2 then betacut = beta[s,1:(&ncat-2)];
            probb= probfut(betax,betacut, &ncat, xtemp, ntem);

            status= rantbl(&seed, probb[,1] %do kkk=2 %to %eval(&ncat-1); , (probb[,&kkk]-probb[,&kkk-1]) %end;);
			 datat[loctem,&nxcov+s]=status;
        end;
     end;

      dataall[(col-1)*(ntot)+(1:ntot),]=datat||j(ntot,1,col);
  end;
  
 
 end;
print accept nmcmc (accept/&npost/nmcmc);
create &betaout from betaall[colname={%do jjj=2 %to %eval(&ncat-1); "cut&jjj" %end;
     &colname %do kkk=1 %to %eval(&npost-1); "y&kkk" %end; 'rep'}];
append from betaall;


create &dataimpout from dataall[colname={&colname %do kkk=1 %to &npost; "y&kkk" %end; 'pattern' 'pid' 'rep'}];
append from dataall;



start autocorr(vector,nleng, lage);
  corr1 =j(1+lage,1,0);
  mu = mean(vector);
  vectoradj =vector-mu;
  corr1[1]= (vectoradj##2)[:];
  do lag=1 to lage;
    var11 = (vectoradj[1:(nleng-lag)]#vectoradj[(lag+1):nleng])[+]/nleng;
    corr1[lag+1]= var11 /corr1[1];
  end;
 return(corr1);
finish;



if &plotafterburn>0 then do;

 corrall= j(&nlag+1, (&ncat-2 + &nxcov)*(&npost)+ sum(1:(&npost-1)),0);
 tag=0;
 do s=1 to &npost;
   do k=1 to (&ncat-2 +&nxcov+s-1);
     cut = betaplot[ (0:(&plotafterburn-1))*(&npost)+s, k];
     tag=tag+1;
     corrall[,tag]= autocorr(cut,&plotafterburn,&nlag);
  end;
  end;
   colname1={%do s=1 %to &npost; 
     %do kkk=2 %to %eval(&ncat-1); "cut&s._&kkk" %end; %do kkk=1 %to &nxcov; "alpha&s._&kkk" %end;
     %do kkk=1 %to %eval(&s-1); "beta&s._&kkk" %end;%end;};

 create autocorr from corrall[colname=colname1];
 append from corrall;
end;

quit;
%mend;



%macro MNAR_imputation_glm(dataimpin=dataall, dataimpout=,
     betain=betaall, method=CR DELTAFIR DELTAALL, delta=0.2,nxcov=2, ncat=4, npost=3,colname=, seed=20000 );
  
  data _null_;
  set &dataimpin end=eof;
  if eof then do;
      call symput('nsample', rep);
	  call symput('ntot', _N_/rep);
  end;
  run; 

  proc iml;
   use &dataimpin;
   read all into dataall;

   use &betain;
   read all into betaall;
 
   start probfut_MNAR(betax, adj, betacut, ncat, xtemp,ntem, deltafir);
    ****for binary, betacut=0;
    ***otherwise, betacut=0,cut1,cut(k-1); 
    *** overall betacut = 0//beta[1:(&ncat-2)];
     if deltafir=1 then   xbeta = xtemp*betax` -adj;  
	 else  xbeta = xtemp*betax`; 
      if &ncat>2 then xbeta = xbeta + shape((0||betacut), ntem, ncat-1);
    	probtemp =1/(1+exp(-xbeta));
     return(probtemp);
   finish;
  
   betacut=0;
   do col=1 to &nsample;
   
	 beta =  betaall[(col-1)*(&npost)+(1:&npost),];
     datat = dataall[(col-1)*(&ntot)+(1:&ntot),];

	 if col=1 then do;
	    pat=datat[, &nxcov+&npost+1];
	    ncpatactive =j(&npost,1,0);
        loccpatactive =j(&npost, &ntot,0); 
        do j=1 to &npost;
		  temp= ((pat<j) & (datat[,&nxcov]=1));
		  ncpatactive[j] =sum(temp);
		  if ncpatactive[j]>0 then do;
		     loctemp=loc(temp);
             loccpatactive[j, 1: ncpatactive[j]]=loctemp;
		  end;
        end;

        npatactive =j(&npost,1,0);
        locpatactive =j(&npost, &ntot,0); 
        do j=1 to &npost;
		  temp= ((pat=j-1) & (datat[,&nxcov]=1));
		  npatactive[j] =sum(temp);
		  if npatactive[j]>0 then do;
		     loctemp=loc(temp);
             locpatactive[j, 1: npatactive[j]]=loctemp;
		  end;
        end;
	 end;

	 do j=1 to &npost;
         if ncpatactive[j]>0 then do;
		    loctemptemp=loccpatactive[j, 1: ncpatactive[j]];
            xtemp =datat[loctemptemp, 1:(&nxcov+j-1)];
	     	betax = beta[j,&ncat-2 +(1:(&nxcov+j-1))];
	    	if &ncat>2 then betacut = beta[j,1:(&ncat-2)];

			if upcase("&method")='CR' then do; 
                 betax[&nxcov]=0; 
				* print col j beta betax;
                 probb= probfut_MNAR(betax,0, betacut, &ncat, xtemp, ncpatactive[j], 0);
				* print probb;
                end;
			else if upcase("&method")='DELTAALL' then do;
               betax[&nxcov]= betax[&nxcov] -&delta;
               probb= probfut_MNAR(betax,0, betacut, &ncat, xtemp, ncpatactive[j], 0);
            end;
	        else if upcase("&method")='DELTAFIR' then do;
			   adj =j(ncpatactive[j],1,0);
			   if npatactive[j]>0 then adj[1: npatactive[j]]=&delta;
               probb= probfut_MNAR(betax,adj, betacut, &ncat, xtemp, ncpatactive[j], 1);
            end;

           status= rantbl(&seed, probb[,1] %do kkk=2 %to %eval(&ncat-1); , (probb[,&kkk]-probb[,&kkk-1]) %end;);
			 datat[loctemptemp,&nxcov+j]=status;
          end;
     end;
    
     dataall[(col-1)*(&ntot)+(1:&ntot),]=datat;
   end;
  create &dataimpout from dataall[colname={&colname %do kkk=1 %to &npost; "y&kkk" %end;'pattern' 'pid' 'rep'}];
  append from dataall;
  quit;
%mend;







%macro logistic_visit(dataimpin=dataall,  cov=trt, cov2=%str(intercept &cov), vis=p,resulttemp=oookkk,ntot=431, missing=MAR, model=GLM);
 ods listing close;
 PROC logistic  data= &dataimpin;
   MODEL  y&vis =  &cov;
   by rep;
   ods output ParameterEstimates=parmi(rename=(rep=_imputation_));
 RUN;
  ods listing;

 proc mianalyze parms(classvar=full)=parmi edf=&ntot;
  modeleffects &cov2;
  ods output ParameterEstimates= &resulttemp VarianceInfo=temptemptemp2 ;
  title "MI analysis summary: &model, &missing, visit &vis"; 
 run;

 data &resulttemp;
 retain model missing visit;
 length missing $10.;
 merge &resulttemp temptemptemp2;
 model="&model";
 missing="&missing";
 visit=&vis;
 run;

%mend;

%macro logis_data_analysis (dataimpin=dataall,nsample=400,
   cov=trt, cov2=%str(intercept trt), ncat=2, npost=3, visit=last, resultout=miest, missing=MAR, model=GLM);
 
data _null_;
retain aaa 0;
set &dataimpin;
by rep;
aaa=aaa+1;
if rep=1;
if last.rep then call symput('ntot', aaa);
run;
%put 'ntot' &ntot;

%if %upcase(&visit)=LAST %then %do;
 %logistic_visit(dataimpin=&dataimpin,cov=&cov, cov2=&cov2, vis=&npost,resulttemp=&resultout,ntot=&ntot, missing=&missing, model=&model);
%end;
%else %do;
 %do kkk=1 %to &npost;
  %logistic_visit(dataimpin=&dataimpin,cov=&cov, cov2=&cov2, vis=&kkk,resulttemp=resulttemp,ntot=&ntot, missing=&missing, model=&model);
   %if &kkk=1 %then %do;
      data &resultout;set resulttemp; run;       
   %end;
   %else %do;
      proc append base=&resultout data=resulttemp force;run;
   %end;

 %end;
%end;

%mend;





%macro data_analysis (dataimpin=dataall,nsample=400, cov=trt, ncat=4, npost=3, method=GEE, GEEcorr=IND, resultout=miest);
  
%if %index(%upcase(&method),GEE)>0 %then %do;
 data datatemp;
 array yy{&npost} y1-y&npost;
 set &dataimpin;
 by rep descending pattern descending trt pid;
 do vis=1 to &npost;
      y= yy[vis]; output;
 end;
 run;
  
ods listing close;
proc genmod data=datatemp;
class  pid vis trt;
 MODEL  y= vis*trt/noint  dist=multinomial
                         link=cumlogit;
   repeated subject=pid / type=&geecorr PRINTMLE;
   estimate 'trtvis' vis*trt %do kkk=1 %to %eval(&npost-1); 0 0 %end; -1 1;
   by rep;  
 ods output ParameterEstimates= parmgeei (rename=(rep=_imputation_)) estimates=estgeei;
 RUN;
ods listing;

data estgeei;
set estgeei;
rename label=parameter rep=_imputation_ lbetaestimate=estimate;
run;

 proc mianalyze parms(classvar=full)=estgeei;
  class  visit ;
  modeleffects trtvis;
  ods output ParameterEstimates= resmi;
 run;
%end;

%if %index(%upcase(&method),LOGIS)>0 %then %do;
 ods listing close;
 PROC logistic  data= &dataimpin;
   MODEL  y&npost =  &cov;
   by rep;
   ods output ParameterEstimates=parmi(rename=(rep=_imputation_));
 RUN;
 ods listing;
 proc mianalyze parms(classvar=full)=parmi;
  modeleffects  &cov;
  ods output ParameterEstimates= resmi;
 run;
%end;

%mend;

