 %let dir=C:\samplecode;
  %include "&dir.\probordPXDA_REPARcore.sas";
 libname tmp1 "&dir";

data raw;
set tmp1.ordinal_sampledata;
run;

*** use probit model to impute and analyze ordinal outcomes;

%MLE_initial (datain=raw, cov=%str(trt), ncat=4,npost=3, out=initial);

%coreprobitord (nxcov=2, npost=3, ncat=4, datain=raw,iniparam=initial, nthin=100, nburn=100000,nsample=1000,Rinv=0,  
             dataimpout=dataall, betaout=betaall,seed=200, colname=%str('int' 'trt'), valmax=999999999999999, 
           PXDA=1, plotafterburn=20000, nlag=200);

%logis_data_analysis (dataimpin=dataall,nsample=1000,
   cov=trt, cov2=intercept trt, ncat=4, npost=3, visit=ALL, resultout=miest, missing=MAR, model=PROBIT);


%MNAR_imputation(dataimpin=dataall,dataimpout=j2r, betain=betaall, method=J2R, delta=0.2,nxcov=2, ncat=4,
         npost=3,colname=%str('int' 'trt'));

%logis_data_analysis (dataimpin=j2r,nsample=1000,
   cov=trt, cov2=intercept trt, ncat=4, npost=3, visit=ALL, resultout=miest_j2r, missing=j2r, model=PROBIT);

%MNAR_imputation(dataimpin=dataall,dataimpout=CR, betain=betaall, method=CR, delta=0.2,nxcov=2, ncat=4,
         npost=3,colname=%str('int' 'trt'));

%logis_data_analysis (dataimpin=CR,nsample=1000,
   cov=trt,cov2=intercept trt,  ncat=4, npost=3, visit=ALL, resultout=miest_Cr, missing=CR, model=PROBIT);

%MNAR_imputation(dataimpin=dataall,dataimpout=DELTAall, betain=betaall, method=Deltaall, delta=-2,nxcov=2, ncat=4,
         npost=3,colname=%str('int' 'trt'));

%logis_data_analysis (dataimpin=DELTAall,nsample=1000,
   cov=trt, cov2=intercept trt,  ncat=4, npost=3, visit=ALL, resultout=miest_deltaall, missing=DELALL, model=PROBIT);



***** use sequential logistic regression to impute and analyze ordianl outcomes;

%include "&dir.\glmimpcore.sas";
%MLE_initial (datain=raw, cov=%str(trt), ncat=4,npost=3, out=initial);
%coreglm (nxcov=2, npost=3,ncat=4, datain=raw,iniparam=initial, nthin=100, nburn=100000,nsample=1000,Rinv=0,  
             dataimpout=dataall, betaout=betaall,seed=200, colname=%str('int' 'trt'),scheme=1,
          plotafterburn=20000, nlag=200);

%logis_data_analysis (dataimpin=dataall,nsample=1000,
   cov=trt,   cov2=intercept trt, ncat=4, npost=3, visit=ALL, resultout=miest, missing=MAR, model=GLM);

%MNAR_imputation_glm(dataimpin=dataall, dataimpout=CR,
     betain=betaall, method=CR, delta=0.2,nxcov=2, ncat=4, npost=3,colname=%str('int' 'trt'), seed=20000 );

%logis_data_analysis (dataimpin=CR,nsample=1000,
   cov=trt,   cov2=intercept trt, ncat=4, npost=3, visit=ALL, resultout=miest_CR, missing=CR, model=GLM);

%MNAR_imputation_glm(dataimpin=dataall, dataimpout=deltaall,
     betain=betaall, method=deltaall, delta=1,nxcov=2, ncat=4, npost=3,colname=%str('int' 'trt'), seed=20000 );

%logis_data_analysis (dataimpin=deltaall,nsample=1000,
   cov=trt,   cov2=intercept trt, ncat=4, npost=3, visit=ALL, resultout=miest_del, missing=deltaall, model=GLM);





