
%macro MLE_initial (datain=raw, cov=%str(y0 trt),ncat=2, npost=3, out=initial);
proc datasets nodetails; delete &out;run;
Ods listing close;
%do kkk=&npost %to 1 %by -1;
 PROC logistic  data=&datain descending;
 %if kkk=1 %then %do;
   MODEL  y&kkk =  &cov /link=PROBIT;
 %end;
 %else %do;
    MODEL  y&kkk =  &cov %do j=1 %to %eval(&kkk-1); y&j %end;/ link=probit;
  %end;
   ods output ParameterEstimates=par&kkk;
 RUN;

  data par&kkk;
  set par&kkk; 
  %if &ncat>2 %then %do;
  if variable='Intercept' then var='int'||left(classVal0);
  else var=variable;
  %end;
  %else %do;
  var=variable;
  %end;
  kkk=&kkk;
  run;

  proc transpose data=par&kkk out=tpar&kkk;
  id  Var;
  var estimate;
  by kkk;
  run;

  proc append base=&out data=tpar&kkk force;run;

%end;
ods listing;
 
 proc sort data=&out;by kkk;run;
 %let kk=%eval(&ncat-1);
 data &out;
 %if &ncat>2 %then %do;
   retain int2-int&kk int1 &cov y1-y&npost;
 %end;
 %else %do;
   retain intercept &cov y1-y&kk;
 %end;
 set &out;
 drop _name_ kkk;
 run;
 proc print data=&out;run;

%mend;






%macro coreprobitbin (nxcov=2, npost=3,ncat=2, datain=raw, iniparam=initial, nthin=1, nburn=100,nsample=400,Rinv=0.01, 
                dataimpout=dataall, betaout=betaall,seed=200,colname= , valmax=999999999999999, maxk=1000, 
               latentscheme=2, PXDA=YES,plotafterburn=10000, nlag=100,nloop=1, extreme=4.5);

**** latentscheme=1  -- rejection algorithm;
**** latentscheme=2  -- Gibbs sampler; 
**** Latentscheme=3 -- new Gibbs sampler;

data misstag;
retain obs totm firstm pattern;
array yy{&npost} y1-y&npost;
array tag{&npost} tag1-tag&npost;
set &datain;
obs=_N_;
totm=0;
do i=1 to pattern-1;
 if yy[i]=. then do; 
   totm=totm+1;
   tag[totm]=i;
  end;
end;
if totm>0;

firstm=tag[1];
keep obs totm firstm tag1-tag&npost pattern;
run;


proc sql noprint;
 select count(*) into :nmiss from work.misstag;
quit;
%put 'nmiss' &nmiss;



proc iml;
  use &datain;
  read all into raw;
  ntot= nrow(raw);
  pat=raw[, &nxcov+&npost+1];

  use misstag;
  read all into miss;
  ****set initial;
  use &iniparam;
  read all into beta; *** store (exp(theta), beta);

  call streaminit(&seed);




   datat=raw;

  catcatcut = j(ntot, &npost, &valmax);
  poscatcut = j(ntot, &npost, 1);
   do i=1 to ntot;
  do s=1 to &npost;
    if (datat[i, &nxcov+s]=1) | (datat[i, &nxcov+s]=2) then catcatcut[i,s]=0;
    if datat[i, &nxcov+s]=2 then poscatcut[i,s]=-1; 
  end;
  end; 


  catcutlow = j(ntot, &npost,-&valmax);
  catcutup = j(ntot, &npost, &valmax);
  do i=1 to ntot;
  do s=1 to &npost;
    if datat[i, &nxcov+s]=1 then catcutup[i,s]=0;
    else if datat[i, &nxcov+s]=2 then catcutlow[i,s]=0; 
  end;
  end; 


   if &nmiss>0 then do;
      use misstag;
      read all into miss;
      if nrow(miss)>0 then do;
           obs=miss[,1];
           tmiss = miss[,2];
           indexall = miss[,  3:4];
           indexmiss = miss[,4+(1:&npost)]; 
          do i=1 to nrow(miss);
             datat[obs[i],&nxcov+ indexmiss[i,1:(tmiss[i])]] = datat[obs[i],&nxcov +indexall[i,2]]; 
          end;
       end;
	
    end;

npatindex = j(&npost,3,0);
nposttrt =j(&npost,1,0);
do j=1 to &npost;
  nposttrt[j]= sum( pat>=j);
  npatindex[j,1]= sum( pat = j);
end;
do j=1 to &npost;
 if  npatindex[j,1]>0 then do;
   if j<&npost then   npatindex[j,2] = nposttrt[j+1]+1;
   else npatindex[j,2] =1;
   npatindex[j,3] = nposttrt[j];
 end;
end;

datat2=datat;


start normal_truncated_gen(Lowb, upperb, extreme, nlen);

 tempL = (upperb< -extreme);
 tempU = (lowb> extreme);
 nL = sum(tempL);
 nU = sum(tempU);

  if (nl=0) & (nU=0) then do;
       plow =probnorm(lowb);
       pup = probnorm(upperb)-plow;   
       ok =  uniform(j(nlen,1,&seed))#pup+plow;
       norvar =probit(ok); 
  end;
  else do;
       norvar = j(nlen,1,.);
	   kk = nlen-nL-nU;
	   if kk>0 then do;
         loccur = loc(1- tempL -tempU);
         plow =probnorm(lowb[loccur]);
         pup = probnorm(upperb[loccur])-plow;   
         ok =  uniform(j(kk,1,&seed))#pup+plow;
         norvar[loccur] =probit(ok);
       end;    
       if nU>0 then do;	
        * print tempU;
         locu= loc(tempU);
         lambda= (lowb[locu]+ sqrt(lowb[locu]##2+4))/2;
         rantem= ranexp(j(nu,1,&seed))/lambda +lowb[locu];
		 do kk=1 to nU;
           do until ( (rantem[kk]< upperb[locu[kk]]) & (uniform(&seed)< exp(- (rantem[kk]-lambda[kk])**2/2)));
             rantem[kk]=ranexp(&seed)/lambda[kk]+lowb[locu[kk]];
            end;
		 end;
           norvar[locu]=rantem;
       end; 
       if nL>0 then do;
         locl= loc(tempL);
         lambda= (-upperB[locl]+ sqrt(upperB[locl]##2+4))/2;
         rantem= ranexp(j(nL,1,&seed))/lambda - upperB[locl];
		 do kk=1 to nl;
           do until ( (rantem[kk]< -lowb[locl[kk]]) & (uniform(&seed)< exp(- (rantem[kk]-lambda[kk])**2/2)));
             rantem[kk]=ranexp(&seed)/lambda[kk]-upperB[locl[kk]];
            end;
		 end;
         norvar[locl]=-rantem;
       end; 
  end;
  return (norvar);
finish;

 ****initial******;
 do s=1 to &npost;
    index=1:(nposttrt[s]); 
     xbeta=datat[index,1:(&nxcov+s-1)]*(beta[s,1:(&nxcov+s-1)])`;
	 lowb=catcutlow[index,s] -xbeta;
	 upperB=catcutup[index,s] -xbeta;
    datat2[index, &nxcov+s] = normal_truncated_gen(Lowb, upperb, &extreme,nposttrt[s])+xbeta;
end;



start drawlatent_rejection(dataxyi ,beta , pati, cutlow, cutup, maxk, mcmc,ii);
  tag=0;
  k=0;    
  do while ((k<= maxk) & (tag< pati));
     ytempall = dataxyi;
     k=k+1;
	 stop=0;
	 tag=0;
     do s=1 to pati while (stop=0);
       xbeta =(ytempall[1:(&nxcov+s-1)])`*(beta[s,1:(&nxcov+s-1)])`;
       ytempall[&nxcov+s]=xbeta+rannor(&seed);
       if (ytempall[&nxcov+s]> cutlow[s]) & (ytempall[&nxcov+s]< cutup[s]) then tag=tag+1;
	   else stop=1;
     end;
  end;
 return (ytempall);
finish;



start drawlatent_gibbs(datat2, beta,nposttrt,npatindex, catcutup,  catcutlow, nloop,mcmc);
   U = -beta[,&nxcov+(1:&npost)];
   L = trisolv(4,U,I(&npost)); ***inverse of U;
  
  **** update subjects in pattern s=1;
   npat1 = npatindex[1,1];
   if npat1 >0 then do;
     index = npatindex[1,2]:npatindex[1,3];
     xbeta = datat2[index, 1:(&nxcov)]*(beta[1, 1:(&nxcov)])`;
     lowb= catcutlow[index,1] -xbeta;
     upperb = catcutup[index,1] -xbeta;
     datat2[index, &nxcov+1]=  normal_truncated_gen(Lowb, upperb, &extreme,npat1)+ xbeta;
   end;

   **** update subjects in pattern s=2;
   if (&npost>=2) then do;
       npat2 = npatindex[2,1];
	  if npat2>0 then do;  
        index =npatindex[2,2]:npatindex[2,3];
	    Ltemp= L[1:2,1:2];
        sigma = Ltemp*(Ltemp`);
        Mean = datat2[index,1:(&nxcov)]*(Ltemp* beta[1:2,1:(&nxcov)])`;
        do ooo=1 to nloop;
        mean1 = mean[,1]+(sigma[1,2]/sigma[2,2])#(datat2[index,&nxcov+2]-mean[,2]);
 
		se1 = sqrt(sigma[1,1]-sigma[1,2]**2/sigma[2,2]);

       * plow =probnorm((catcutlow[index,1] -mean1)/se1);
       * pup = probnorm((catcutup[index,1] -mean1)/se1)-plow;
       * ok= uniform(j(npat2,1,&seed))#pup+plow;
       * datat2[index, &nxcov+1] =  probit(ok)#se1+ mean1;

		lowb=(catcutlow[index,1] -mean1)/se1;
		upperb=(catcutup[index,1] -mean1)/se1;
        datat2[index, &nxcov+1] =normal_truncated_gen(Lowb, upperb, &extreme,npat2)#se1+ mean1;
     
        mean2 = mean[,2]+(sigma[1,2]/sigma[1,1])#(datat2[index,&nxcov+1]-mean[,1]);
		se2 = sqrt(sigma[2,2]-sigma[1,2]**2/sigma[1,1]);

     *   plow =probnorm((catcutlow[index,2] -mean2)/se2);
     *   pup = probnorm((catcutup[index,2] -mean2)/se2)-plow;
	 *	ok= uniform(j(npat2,1,&seed))#pup+plow;   
     *   datat2[index, &nxcov+2] =  probit(ok)#se2+ mean2;
	    lowb=(catcutlow[index,2] -mean2)/se2;
	 	upperb=(catcutup[index,2] -mean2)/se2;
        datat2[index, &nxcov+2] =normal_truncated_gen(Lowb, upperb, &extreme,npat2)#se2+ mean2;
        end;
      end;
   end;

 
   do s=3 to &npost;
   **** update subjects in pattern s>=3;
      npats = npatindex[s,1];
	  if npats>0 then do;
        index =(npatindex[s,2]):(npatindex[s,3]);
	     Ltemp= L[1:s,1:s];
        sigma = Ltemp*(Ltemp`);
        Mean = datat2[index,1:(&nxcov)]*(Ltemp* beta[1:s,1:(&nxcov)])`;

		invsigma = U[1:s,1:s];	
		invsigma = invsigma`*invsigma;



        do ooo=1 to nloop;	   

		  do t=1 to s;
              if t=1 then  index2 = (2:s);
			  else if t=s then index2=1:(s-1);
		      else index2 = (1:(t-1))||((t+1):s);
             
			  invsigt = invsigma[index2,index2] - invsigma[index2,t]*(invsigma[t,index2]/invsigma[t,t]);             	
              meant=mean[,t]+ (datat2[index,&nxcov+index2]-mean[,index2])* (invsigt*sigma[index2,t]);   
			  set =sqrt( sigma[t,t]-sigma[t,index2]*invsigt* sigma[index2,t]);

            *  plow =probnorm((catcutlow[index,t] -meant)/set);
            * pup = probnorm((catcutup[index,t] -meant)/set)-plow;
			*  ok=uniform(j(npats,1,&seed))#pup+plow;
            *  datat2[index, &nxcov+t] =  probit(ok) # set+ meant;
    	      lowb=(catcutlow[index,t] -meant)/set;
      	 	upperb=(catcutup[index,t] -meant)/set;
            datat2[index, &nxcov+t] =normal_truncated_gen(Lowb, upperb, &extreme,npats)#set+ meant;
         end;
	      end;
      end;
   end;

   return (datat2);
finish;




start drawlatent_gibbs_new(datat2, beta,nposttrt,npatindex, catcutup, catcutlow, nloop, mcmc);
   U = -beta[,&nxcov+(1:&npost)];
   L = trisolv(4,U,I(&npost)); ***inverse of U;
  
  **** update subjects in pattern s=1;
   npat1 = npatindex[1,1];
   if npat1 >0 then do;
     index = npatindex[1,2]:npatindex[1,3];
     xbeta = datat2[index, 1:(&nxcov)]*(beta[1, 1:(&nxcov)])`;
 	 lowb=catcutlow[index,1]-xbeta;
	 upperb=catcutup[index,1]-xbeta;
     datat2[index, &nxcov+1]=normal_truncated_gen(Lowb, upperb, &extreme,npat1)+xbeta; 
   end;

   do s=2 to &npost;
   **** update subjects in pattern s>=2;
      npats = npatindex[s,1];
	  if npats>0 then do;
         index =(npatindex[s,2]):(npatindex[s,3]);
	     Ltemp= L[1:s,1:s];
         sigma = Ltemp*(Ltemp`);
         Mean = datat2[index,1:(&nxcov)]*(Ltemp* beta[1:s,1:(&nxcov)])`;
		 indexoutcome= &nxcov+(1:s);
         Error = (datat2[index,indexoutcome] -mean)*(U[1:s,1:s])`;
         catcutup_temp =  catcutup[index,1:s]-mean;
         catcutlow_temp=  catcutlow[index,1:s]-mean;

         do ooo=1 to nloop;
     	  do t=s to 1 by -1;
              if t=1 then  index2 = (2:s);
			  else if t=s then index2=1:(s-1);
		      else index2 = (1:(t-1))||((t+1):s);
             
			 index3 =(t:s);
			 temp=error[,index2]* (L[index3,index2])`;	
             catcutup_tempt = catcutup_temp[,index3] - temp;
             catcutlow_tempt = catcutlow_temp[,index3] - temp;

			 catcutup_temptemp= j(npats, s-t+1, &valmax);
             catcutlow_temptemp= j(npats, s-t+1, -&valmax);
              temp2=(L[index3,t])`;
              do kk=  t to s;
			   lambda =temp2[kk-t+1];
			   if lambda>0 then do;
                  catcutup_temptemp[,kk-t+1]=catcutup_tempt[,kk-t+1]/lambda;
                  catcutlow_temptemp[,kk-t+1]=catcutlow_tempt[,kk-t+1]/lambda;
			    end;
				else if lambda<0 then do; 
                   catcutlow_temptemp[,kk-t+1]=catcutup_tempt[,kk-t+1]/lambda;
                   catcutup_temptemp[,kk-t+1]=catcutlow_tempt[,kk-t+1]/lambda;
				end;
              end;
       
               elow= catcutlow_temptemp[,<>];
			   eup = catcutup_temptemp[,><];
              error[, t] =  normal_truncated_gen(elow, eup, &extreme,npats); 
	      end;
      end;
      end;	 
       datat2[index,indexoutcome] =  mean+ error *Ltemp`;
   end;
   return (datat2);
finish;




nmcmc=&nsample * &nthin +(&nburn);
beta=J(&npost, &nxcov + &npost,0);
beta[, &nxcov+(1:(&npost))]= -I(&npost);



ncolraw = ncol(raw);
rrsqrt = j(&nxcov,1,1)//j(&npost,1,1);

betaall =j(&npost*&nsample,  &ncat-2+&nxcov + &npost+1,.);
dataall =j(ntot*&nsample,  &nxcov + 2*&npost+3,.);
if (&plotafterburn>0) then 
   betaplot = j(&npost*&plotafterburn,  &ncat-2+&nxcov + &npost+1,.);


do mcmc=1 to  nmcmc;
 *** update beta;
 do s=1 to &npost;
   index1=1:(&nxcov+s-1);
   index2=&nxcov+s;
   temp=datat2[1:(nposttrt[s]),index1||index2];
   zz =temp`*temp;
   %if %upcase(&PXDA)^=YES %then %do;
     if &rinv=0 then do;  
       Lx=root(zz);
       mtemp = Lx[index1,index2] + rannor(j(&nxcov+s-1,1,&seed));
       Beta[s,1:(&nxcov+s-1)]  =(trisolv(1,Lx[index1,index1],mtemp))`;
	 end;
	 else do;
       Vinvbeta =  zz[ index1,index1]+ &Rinv#I(&nxcov+s-1);
	   Bxy = zz[index1,index2];
	   LXB= root(Vinvbeta);
       mtemp = rannor(j(&nxcov+s-1,1,&seed))+TRISOLV(2, LXB, BXY); 
       Beta[s,1:(&nxcov+s-1)]  =(trisolv(1,Lxb,mtemp))`;
	 end;
   %end;
   %if %upcase(&PXDA)=YES %then %do;  
     if &rinv=0 then do;  
       Lx=root(zz);
       SSEsqrt= LX[index2,index2];
       rrsqrt[index2]=sqrt(2*rangam(&seed,nposttrt[s]/2))/SSEsqrt;
       mtemp = Lx[index1,index2]# rrsqrt[index2] + rannor(j(&nxcov+s-1,1,&seed));
       Beta[s,1:(&nxcov+s-1)]  =(trisolv(1,Lx[index1,index1],mtemp)/rrsqrt[index1])`;
      
    
	  end;
      else do;
         Lx=root(zz);
         SSEsqrt= LX[index2,index2];
         rrsqrt[index2]=sqrt(2*rangam(&seed,nposttrt[s]/2))/SSEsqrt;
        Vinvbeta =  zz[ index1,index1]+ diag(&Rinv/rrsqrt[index1]/rrsqrt[index1]);
        Bxy = zz[index1,index2];
	    LXB= root(Vinvbeta);
       	
        mtemp = rannor(j(&nxcov+s-1,1,&seed))+ TRISOLV(2, LXB, BXY)# rrsqrt[index2]; 
        Beta[s,1:(&nxcov+s-1)]  =(trisolv(1,Lxb,mtemp)/rrsqrt[index1])`;
      end;
   %end;
 end;


 *** update Z;
if &latentscheme=1 then do;
 do i=1 to nposttrt[1]; 
  datat2[i,] = drawlatent_rejection(datat2[i,], beta, pat[i], catcutlow[i,], catcutup[i,], &maxk,mcmc,i);
 end;
end;
else if &latentscheme=2 then do;
nloop=&nloop;
 datat2=drawlatent_gibbs(datat2, beta,nposttrt, npatindex, catcutup,  catcutlow,  nloop,mcmc);
end;
else if &latentscheme=3 then do;
nloop=&nloop;
 datat2=drawlatent_gibbs_new(datat2, beta,nposttrt, npatindex, catcutup,  catcutlow, nloop,mcmc);
end;

  col = (mcmc -&nburn)/&nthin;

  if (&plotafterburn>0) & (mcmc> &nburn) & (mcmc<=&nburn+&plotafterburn) then do;
   ntempplot=mcmc-&nburn;
   betaplot[(ntempplot-1)*(&npost)+(1:(&npost)),]= beta||J(&npost,1,ntempplot);
  end;

  if (col >0) & (int(col)=col) then do; 
      betaall[(col-1)*(&npost)+(1:&npost),]= beta||J(&npost,1,col);
      if col=1 then nnmistemp=0;
      do s=1 to &npost;
      if nposttrt[s]< ntot then do;
	       index = (nposttrt[s]+1):ntot;
           datat2[index, &nxcov+s]  =datat2[index,1:(&nxcov+s-1)]*(beta[s,1:(&nxcov+s-1)])`+rannor(j(ntot-nposttrt[s],1,&seed));
		*   datat[index,&nxcov+s]=(datat2[index, &nxcov+s]>0)+1;
          if col=1 then do;
            nnmistemp=nnmistemp+1;
		    if  nnmistemp=1 then indexmissdrop = (index-1)#ncolraw+&nxcov+s;
		    else indexmissdrop =indexmissdrop||((index-1)#ncolraw+&nxcov+s);
		  end;
	  end;
      end;
        datat[indexmissdrop]=  1+    (datat2[indexmissdrop]>=0);
    if &nmiss>0 then do;
	     if col=1 then do;
          do i=1 to nrow(miss);
            if i=1 then indexmissint = (obs[i]-1)*ncolraw+&nxcov+ indexmiss[i,1: tmiss[i]];
			else indexmissint=indexmissint|| ((obs[i]-1)*ncolraw+&nxcov+ indexmiss[i,1: tmiss[i]]);
		  end;
		 end;
        * do i=1 to nrow(miss);
        *  datat[obs[i],&nxcov+ indexmiss[i,1:(tmiss[i])]] = (datat2[obs[i],&nxcov+ indexmiss[i,1:(tmiss[i])]]>0)+1; 
        *end;
            datat[indexmissint]= 1+    (datat2[indexmissint]>=0);
    end;

    dataall[(col-1)*ntot+(1:ntot),]=datat|| datat2[, &nxcov+(1:&npost)]||J(ntot,1,col);
  end;


end;


create &betaout from betaall[colname={&colname %do kkk=1 %to %eval(&npost-1); "y&kkk" %end; 'rep'}];
append from betaall;

create &dataimpout from dataall[colname={&colname %do kkk=1 %to &npost; "y&kkk" %end;'pattern' 'pid' 
        %do kkk=1 %to &npost; "w&kkk" %end;   'rep'}];
append from dataall;


start autocorr(vector,nleng, lage);
  corr1 =j(1+lage,1,0);
  mu = mean(vector);
  vectoradj =vector-mu;
  corr1[1]= (vectoradj##2)[:];
  do lag=1 to lage;
    var11 = (vectoradj[1:(nleng-lag)]#vectoradj[(lag+1):nleng])[+]/nleng;
    corr1[lag+1]= var11 /corr1[1];
  end;
 return(corr1);
finish;

if &plotafterburn>0 then do;
 corrall= j(&nlag+1, (&nxcov)*(&npost)+ sum(1:(&npost-1)),0);
 tag=0;
 do s=1 to &npost;
   do k=1 to &nxcov+s-1;
     cut = betaplot[ (0:(&plotafterburn-1))*(&npost)+s, k];
     tag=tag+1;
     corrall[,tag]= autocorr(cut,&plotafterburn,&nlag);
  end;
 end;
 
  colname1={%do s=1 %to &npost; 
       %do kkk=1 %to &nxcov; "alpha&s._&kkk" %end;  
       %do kkk=1 %to %eval(&s-1); "beta&s._&kkk" %end;
     %end; };
  
 create autocorr from corrall[colname=colname1];
 append from corrall;
end;

quit;
%mend;




%macro MNAR_imputation_probitbin(dataimpin=dataall, dataimpout=,
     betain=betaall, method=J2R CR DELTAFIR DELTAALL, delta=0.2,nxcov=2, ncat=4, npost=3,colname= );
  
  data _null_;
  set &dataimpin end=eof;
  if eof then do;
      call symput('nsample', rep);
	  call symput('ntot', _N_/rep);
  end;
  run; 

  proc iml;
   use &dataimpin;
   read all into dataall;

   use &betain;
   read all into betaall;
 
   do col=1 to &nsample;
   
	 beta =  betaall[(col-1)*(&npost)+(1:&npost),];
   
     datat = dataall[(col-1)*(&ntot)+(1:&ntot),];

	 if col=1 then do;
	     idenmatrix =I(&npost);
	     pat =datat[, &nxcov+&npost+1];
	     npatactive =j(&npost,1,0);
         locpatactive =j(&npost, &ntot,0); 
		 ncolraw = ncol(datat);
		 tag=0;
		
        do j=1 to &npost;
		  temp= ((pat=(j-1)) & (datat[,&nxcov]=1));
		  npatactive[j] =sum(temp);
		  if npatactive[j]>0 then do;
		     loctemp=loc(temp);
             locpatactive[j, 1: npatactive[j]]=loctemp;
             locpattemp= shape((loctemp-1)*ncolraw, &npost-j+1, npatactive[j])+((j:&npost)`+&nxcov);
			 locpattemp= shape(locpattemp, (&npost-j+1)*npatactive[j],1);
             tag=tag+1;
			 if tag=1 then  indexalldroppos =locpattemp;
		     else indexalldroppos =indexalldroppos //locpattemp;
		  end;
        end;
          indexalldroppos2=indexalldroppos+&npost+2; 
	 end;


	 U = -beta[, &ncat-2 +&nxcov +(1:&npost)];
     L = trisolv(4,U,idenmatrix); ***inverse of U;
   

	if upcase("&method")='J2R' then  effadj = L* beta[,&ncat-2 +&nxcov];
	else if upcase("&method")='DELTAFIR' then do;
       betaadj =j(&npost,1,0); betaadj[1]=&delta;
    end; 
	else if upcase("&method")='DELTAALL' then betaadj =j(&npost,1,&delta);
 

    do j=1 to &npost;
	    if npatactive[j]>0 then do;
	
		 index=locpatactive[j, 1: npatactive[j]];	 
		 index2=(j:&npost);
		 index3=index2+&nxcov+&npost+2;
          *****adjustment for subjects in pattern (j-1) -- active subjects only;
		 
	

        if upcase("&method")='J2R' then 
          datat[index,index3]= datat[index,index3] -(effadj[index2])`; 
		else if upcase("&method")='CR' then
          datat[index,index3]= datat[index,index3] -(L[index2,index2]*beta[index2,&ncat-2 +&nxcov])`; 
        else if upcase("&method")='DELTAALL' then 
          datat[index,index3]= datat[index,index3] -(L[index2,index2]*betaadj[index2])`;
        else if upcase("&method")='DELTAFIR' then 
		    datat[index,index3]= datat[index,index3] -(L[index2,index2]*betaadj[1:(&npost-j+1)])`;
      end;
    end;

       datat[indexalldroppos]= 1+(datat[indexalldroppos2]>0);
	
      dataall[(col-1)*(&ntot)+(1:&ntot),]=datat;
   end;
  create &dataimpout from dataall[colname={&colname %do kkk=1 %to &npost; "y&kkk" %end;'pattern' 'pid' 
        %do kkk=1 %to &npost; "w&kkk" %end;   'rep'}];
  append from dataall;
  quit;
%mend;


%macro logistic_visit(dataimpin=dataall, cov=y0 trt,cov2=intercept y0 trt,vis=p,resulttemp=oookkk,ntot=431, missing=MAR, model=probit);
 ods listing close;
 PROC logistic  data= &dataimpin;
   MODEL  y&vis =  &cov;
   by rep;
   ods output ParameterEstimates=parmi(rename=(rep=_imputation_));
 RUN;
  ods listing;

 proc mianalyze parms(classvar=full)=parmi edf=&ntot;
  modeleffects &cov2;
  ods output ParameterEstimates= &resulttemp  VarianceInfo=temptemptemp2;
  title "MI analysis summary: &model, &missing, visit &vis"; 
 run;


 data &resulttemp;
 retain model missing visit;
 length missing $10.;
merge &resulttemp temptemptemp2;
 model="&model";
 missing="&missing";
 visit=&vis;
 run;

%mend;

%macro logis_data_analysis (dataimpin=dataall,nsample=400,
   cov=y0 trt,cov2=intercept y0 trt, ncat=2, npost=3, visit=last, resultout=miest, missing=MAR, model=PROBIT);
 
data _null_;
retain aaa 0;
set &dataimpin;
by rep;
aaa=aaa+1;
if rep=1;
if last.rep then call symput('ntot', aaa);
run;
%put 'ntot' &ntot;

%if %upcase(&visit)=LAST %then %do;
 %logistic_visit(dataimpin=&dataimpin,cov=&cov, cov2=&cov2, vis=&npost,resulttemp=&resultout,ntot=&ntot, missing=&missing, model=&model);
%end;
%else %do;
 %do kkk=1 %to &npost;
  %logistic_visit(dataimpin=&dataimpin,cov=&cov, cov2=&cov2, vis=&kkk,resulttemp=resulttemp,ntot=&ntot, missing=&missing, model=&model);
   %if &kkk=1 %then %do;
      data &resultout;set resulttemp; run;       
   %end;
   %else %do;
      proc append base=&resultout data=resulttemp force;run;
   %end;

 %end;
%end;

%mend;





%macro data_analysis (dataimpin=dataall,nsample=400, cov=trt, ncat=4, npost=3, method=GEE, GEEcorr=IND, resultout=miest);
  
%if %index(%upcase(&method),GEE)>0 %then %do;
 data datatemp;
 array yy{&npost} y1-y&npost;
 set &dataimpin;
 by rep descending pattern descending trt pid;
 do vis=1 to &npost;
      y= yy[vis]; output;
 end;
 run;
  
ods listing close;
proc genmod data=datatemp;
class  pid vis trt;
 MODEL  y= vis*trt/noint  dist=multinomial
                         link=cumlogit;
   repeated subject=pid / type=&geecorr PRINTMLE;
   estimate 'trtvis' vis*trt %do kkk=1 %to %eval(&npost-1); 0 0 %end; -1 1;
   by rep;  
 ods output ParameterEstimates= parmgeei (rename=(rep=_imputation_)) estimates=estgeei;
 RUN;
ods listing;

data estgeei;
set estgeei;
rename label=parameter rep=_imputation_ lbetaestimate=estimate;
*proc print;
run;

 proc mianalyze parms(classvar=full)=estgeei;
  class  visit ;
  modeleffects trtvis;
  ods output ParameterEstimates= resmi;
 run;
%end;

%if %index(%upcase(&method),LOGIS)>0 %then %do;
 ods listing close;
 PROC logistic  data= &dataimpin;
   MODEL  y&npost =  &cov;
   by rep;
   ods output ParameterEstimates=parmi(rename=(rep=_imputation_));
 RUN;
 ods listing;
 proc mianalyze parms(classvar=full)=parmi;
  modeleffects &cov;
  ods output ParameterEstimates= resmi;
 run;
%end;

%mend;

