
%macro MLE_initial (datain=raw, cov=%str(y0 trt),ncat=2, npost=3, out=initial);
proc datasets nodetails; delete &out;run;
Ods listing close;
%do kkk=&npost %to 1 %by -1;
 PROC logistic  data=&datain descending;
 %if kkk=1 %then %do;
   MODEL  y&kkk =  &cov /link=PROBIT;
 %end;
 %else %do;
    MODEL  y&kkk =  &cov %do j=1 %to %eval(&kkk-1); y&j %end;/ link=probit;
  %end;
   ods output ParameterEstimates=par&kkk;
 RUN;

  data par&kkk;
  set par&kkk; 
  %if &ncat>2 %then %do;
  if variable='Intercept' then var='int'||left(classVal0);
  else var=variable;
  %end;
  %else %do;
  var=variable;
  %end;
  kkk=&kkk;
  run;

  proc transpose data=par&kkk out=tpar&kkk;
  id  Var;
  var estimate;
  by kkk;
  run;

  proc append base=&out data=tpar&kkk force;run;

%end;
ods listing;
 
 proc sort data=&out;by kkk;run;
 %let kk=%eval(&ncat-2);
 data &out;
 %if &ncat>2 %then %do;
   retain int3-int&ncat int2 &cov y1-y&npost;
 %end;
 %else %do;
   retain intercept &cov y1-y&kk;
 %end;
 set &out;
 %do jjj=3 %to &ncat;
   int&jjj = int2 - int&jjj;
 %end;
 rename int2=int %do jjj=3 %to &ncat; int&jjj = c%eval(&jjj-1) %end;;
 drop _name_ kkk;
 run;
 proc print data=&out;run;

%mend;





%macro coreprobitord (nxcov=2, npost=3,ncat=4, datain=raw, iniparam=initial, nthin=1, nburn=100,nsample=400,Rinv=0.00001, 
                dataimpout=dataall, betaout=betaall,seed=200,colname= , valmax=999999999999999, 
               PXDA=1,plotafterburn=10000, nlag=100);

**** PXDA=0  -- algorithm without PX;
**** PXDA=1  -- Algorithm with PX, Blocking updating gamma1, then gamma2,..gammap, and then Beta;
  *** PXDA=1 is preferred;
**** PXDA=2  -- Algorithm with PX, update gamma1 given other parameter; 
**** PXDA=3  -- Algorithm with rescaling subject to c(ncat-1)=1;
**** PXDA=4  -- Algorithm with rescaling subject to c(2)=1;

data misstag;
retain obs totm firstm pattern;* tag1-tag&npost;
array yy{&npost} y1-y&npost;
array tag{&npost} tag1-tag&npost;
set &datain;
obs=_N_;
totm=0;
do i=1 to pattern-1;
 if yy[i]=. then do; 
   totm=totm+1;
   tag[totm]=i;
  end;
end;
if totm>0;

*toto=totm;
*do i=tag1+1 to pattern;
*   if yy[i]^=. then do; 
*   toto=toto+1;
*   tag[toto]=i;
*  end;
*end;
firstm=tag[1];
keep obs totm firstm tag1-tag&npost pattern;
run;


proc sql noprint;
 select count(*) into :nmiss from work.misstag;
quit;
%put 'nmiss' &nmiss;



proc iml;
  use &datain;
  read all into raw;
  ntot= nrow(raw);
  pat=raw[, &nxcov+&npost+1];

  use misstag;
  read all into miss;
  ****set initial;
  use &iniparam;
  read all into beta; *** store (exp(theta), beta);

  call streaminit(&seed);




   datat=raw;
   if &nmiss>0 then do;
      use misstag;
      read all into miss;
        print 'miss' (nrow(miss));
      if nrow(miss)>0 then do;
           obs=miss[,1];
           tmiss = miss[,2];
           indexall = miss[,  3:4];
           indexmiss = miss[,4+(1:&npost)]; 
         do i=1 to nrow(miss);
             datat[obs[i],&nxcov+ indexmiss[i,1:(tmiss[i])]] = datat[obs[i],&nxcov +indexall[i,2]]; 
          end;
       end;
    end;

  cutpoint = beta[:,1:(&ncat-2)];
  if &PXDA=3 then do;
    sigtemp= 1/cutpoint[&ncat-2];
    if &ncat>3 then cutpoint[1:(&ncat-3)]=cutpoint[1:(&ncat-3)]/cutpoint[&ncat-2];
    cutpoint[&ncat-2]=1;
  end; 
  else if &PXDA=4 then do;
    sigtemp= 1/cutpoint[1];
    if &ncat>3 then cutpoint[2:(&ncat-2)]=cutpoint[2:(&ncat-2)]/cutpoint[1];
    cutpoint[1]=1;
  end;
  else sigtemp=1;

  cutlow= j(1,1,-&valmax)||j(1,1,0)||cutpoint ;
  cutup=j(1,1,0)||cutpoint||j(1,1,&valmax);
  
 * print cutpoint;
 datat2=datat;
 ****initial******;
 do i=1 to ntot;
   do s=1 to pat[i];
     xbeta=datat[i,1:(&nxcov+s-1)]*(beta[s,(1:(&nxcov+s-1))+(&ncat-2)])`;
     datat2[i, &nxcov+s] = (xbeta+ rannor(&seed))/sigtemp;
     temp=raw[i,&nxcov+s];
	 if temp^=. then do;
       do while ((datat2[i, &nxcov+s]< cutlow[temp]) | (datat2[i, &nxcov+s] > cutup[temp]));   
           datat2[i, &nxcov+s] = (xbeta+ rannor(&seed))/sigtemp;
       end;
	  end;
   end;
end;



start drawlatent_gibbs(datat2, beta,lambdainv, nposttrt,npatindex, raw2, catcutlow, catcutup, mcmc);
   U = -beta[,&nxcov+(1:&npost)];
   L = trisolv(4,U,I(&npost)); ***inverse of U;
  **** update subjects in pattern s=1;
   npat1 = npatindex[1,1];
   if npat1 >0 then do;
     index = npatindex[1,2]:npatindex[1,3];
     xbeta = datat2[index, 1:(&nxcov)]*(beta[1, 1:(&nxcov)])`;
	 se1= sqrt(1/lambdainv[1]);
     plow =probnorm((catcutlow[raw2[index,1]] -xbeta)/se1);
     pup = probnorm((catcutup[raw2[index,1]] -xbeta)/se1)-plow;
	 ok=uniform(j(npat1,1,&seed))#pup+plow;    
     datat2[index, &nxcov+1] =  probit(ok)#se1 + xbeta;
   end;

 
   **** update subjects in pattern s=2;
   if (&npost>=2) then do;
       npat2 = npatindex[2,1];
	  if npat2>0 then do;  
        index =npatindex[2,2]:npatindex[2,3];
	    Ltemp= L[1:2,1:2];
		Lambda=diag(1/lambdainv[1:2]);
        sigma = Ltemp*Lambda*(Ltemp`);
        Mean = datat2[index,1:(&nxcov)]*(Ltemp* beta[1:2,1:(&nxcov)])`;

        mean1 = mean[,1]+(sigma[1,2]/sigma[2,2])#(datat2[index,&nxcov+2]-mean[,2]);
		se1 = sqrt(sigma[1,1]-sigma[1,2]**2/sigma[2,2]);

        plow =probnorm((catcutlow[raw2[index,1]] -mean1)/se1);
        pup = probnorm((catcutup[raw2[index,1]] -mean1)/se1)-plow;
        ok= uniform(j(npat2,1,&seed))#pup+plow;
        datat2[index, &nxcov+1] =  probit(ok)#se1+ mean1;
          
        mean2 = mean[,2]+(sigma[1,2]/sigma[1,1])#(datat2[index,&nxcov+1]-mean[,1]);
		se2 = sqrt(sigma[2,2]-sigma[1,2]**2/sigma[1,1]);

        plow =probnorm((catcutlow[raw2[index,2]] -mean2)/se2);
        pup = probnorm((catcutup[raw2[index,2]] -mean2)/se2)-plow;
		ok= uniform(j(npat2,1,&seed))#pup+plow;
        datat2[index, &nxcov+2] =  probit(ok)#se2+ mean2;
      end;
   end;

 
   do s=3 to &npost;
   **** update subjects in pattern s>=3;
      npats = npatindex[s,1];
	  if npats>0 then do;
        index =(npatindex[s,2]):(npatindex[s,3]);
	     Ltemp= L[1:s,1:s];
         Lambda=diag(1/lambdainv[1:s]);
        sigma = Ltemp*Lambda*(Ltemp`);
        Mean = datat2[index,1:(&nxcov)]*(Ltemp* beta[1:s,1:(&nxcov)])`;

		invsigma = U[1:s,1:s];	
		invsigma = invsigma`*diag(lambdainv[1:s])*invsigma;

       * print sigma invsigma (sigma*invsigma);
		  do t=1 to s;
              if t=1 then  index2 = (2:s);
			  else if t=s then index2=1:(s-1);
		      else index2 = (1:(t-1))||((t+1):s);
             
			  invsigt = invsigma[index2,index2] - invsigma[index2,t]*(invsigma[t,index2]/invsigma[t,t]);

			*  print 'check' invsigt (invsigt*sigma[index2,index2]);
             	
              meant=mean[,t]+ (datat2[index,&nxcov+index2]-mean[,index2])* (invsigt*sigma[index2,t]);   
			  set =sqrt( sigma[t,t]-sigma[t,index2]*invsigt* sigma[index2,t]);

            *  print t index2 meant set;

              plow =probnorm((catcutlow[raw2[index,t]] -meant)/set);
              pup = probnorm((catcutup[raw2[index,t]] -meant)/set)-plow;
			  ok=uniform(j(npats,1,&seed))#pup+plow;
              datat2[index, &nxcov+t] =  probit(ok) # set+ meant;
	      end;
      end;
   end;

   return (datat2);
finish;



ncolraw = ncol(raw);
nmcmc=&nsample * &nthin +(&nburn);
beta=J(&npost, &nxcov + &npost,0);
beta[, &nxcov+(1:(&npost))]= -I(&npost);

betaall =j(&npost*&nsample,  &ncat-2+&nxcov + &npost+2,.);
dataall =j(ntot*&nsample,  &nxcov + 2*&npost+3,.);
if (&plotafterburn>0) then 
   betaplot = j(&npost*&plotafterburn,  &ncat-2+&nxcov + &npost+2,.);

npatindex = j(&npost,3,0);

nposttrt =j(&npost,1,0);
do j=1 to &npost;
  nposttrt[j]= sum( pat>=j);
  npatindex[j,1]= sum( pat = j);
end;
do j=1 to &npost;
 if  npatindex[j,1]>0 then do;
   if j<&npost then   npatindex[j,2] = nposttrt[j+1]+1;
   else npatindex[j,2] =1;
   npatindex[j,3] = nposttrt[j];
 end;
end;

*print nposttrt npatindex;

raw2=raw[,&nxcov+(1:&npost)];
%do kkk=1 %to &ncat;
  loc&kkk =loc( raw2=&kkk);
%end;

locmiss = loc(raw2=.);
raw2[locmiss]=&ncat+1;

minmax=j(&ncat,2,0);

rrsqrt = j(&nxcov,1,1)//j(&npost,1,1);

if &PXDA<3 then  do; catlowupdate=1; catupupdate=&ncat-2;end;
else if &PXDA=3 then   do;
  catlowupdate=1; 
  catupupdate=&ncat-3; 
end;
if &PXDA=4 then   do;
  catlowupdate=2; 
  catupupdate=&ncat-2; 
end;


**** for scale, c(&ncat-1)=1 is fixed;

lambdainv=j(&npost,1,1);
r1sqrt=1;
do mcmc=1 to  nmcmc;
 *** update beta;
 do s=1 to &npost;
   index1=1:(&nxcov+s-1);
   index2=&nxcov+s;
   temp=datat2[1:(nposttrt[s]),index1||index2];
   zz =temp`*temp;
   Lx=root(zz); 
   SSE= LX[index2,index2]##2;
  if &PXDA^=1 then do;
     if (&PXDA=0) | (&PXDA=2) then do;
       if s=1 then lambdainv[s]=1;
	   else lambdainv[s]= 2*rangam(&seed,nposttrt[s]/2)/SSE;
	 end;
     if &PXDA>=3 then lambdainv[s]= 2*rangam(&seed,nposttrt[s]/2)/SSE;
     gammatsqrt=sqrt(lambdainv[s]);  
     mtemp = Lx[index1,index2] + rannor(j(&nxcov+s-1,1,&seed))/gammatsqrt;
     Beta[s,1:(&nxcov+s-1)]  =(trisolv(1,Lx[index1,index1],mtemp))`;
   end;
   else if &PXDA =1 then do;   
	 if s=1 then do;
            r1 = 2*rangam(&seed,nposttrt[1]/2+(&ncat-2)/2)/SSE;
			r1sqrt=sqrt(r1);
			rrsqrt[&nxcov+(1:&npost)]=r1sqrt;
			lambdainv[s]=1;
	 end;
	 else lambdainv[s] = 2*rangam(&seed,nposttrt[s]/2)/SSE/r1;
	 gammat=sqrt(lambdainv[s]);
     mtemp = Lx[index1,index2]# r1sqrt  + rannor(j(&nxcov+s-1,1,&seed))/gammat;
     Beta[s,index1]  =(trisolv(1,Lx[index1,index1],mtemp)/rrsqrt[index1])`;
   end;
  end;
   
*** update latent variabe and cutoff point **********;    
  if &PXDA =1 then do;  
     datat2[, &nxcov+(1:&npost)] =datat2[, &nxcov+(1:&npost)]#r1sqrt;
     cutpoint =cutpoint#r1sqrt;
   end;

  if &PXDA =2 then do;  
    gammab=0;
	gammaa=&ncat-2;
    do s=1 to &npost;
     index1=1:(&nxcov+s-1);
     index2=&nxcov+s;
	 sset =datat2[1:(nposttrt[s]),index2]- datat2[1:(nposttrt[s]),index1]*(Beta[s,index1])`;
     sset=sset`*sset;
	 gammab=gammab+sset * lambdainv[s];
	 gammaa=gammaa +nposttrt[s]+ &nxcov;
    end;
      r1 = 2*rangam(&seed,gammaa/2)/gammab;
	  r1sqrt=sqrt(r1);
  *    print mcmc  gammaa gammab r1 lambdainv;
      datat2[, &nxcov+(1:&npost)] =datat2[, &nxcov+(1:&npost)]#r1sqrt;
      cutpoint =cutpoint#r1sqrt;
      beta[,1:(&nxcov)] =beta[,1:(&nxcov)]#r1sqrt;
   end;


  tempz =datat2[, &nxcov+(1:&npost)];
  %do kkk = 1 %to &ncat;
    tem=tempz[loc&kkk];
    minmax[&kkk,1]= min(tem);
	minmax[&kkk,2]=max(tem);
  %end;


   do s=catlowupdate to catupupdate;
     low= minmax[s+1,2]; up = minmax[s+2,1];
	* if s>2 then  low1=max(low, cutpoint[s-2]); *** These two steps are unnecessary;
	* if s<&ncat-1 then up=min(up, cutpoint[s]);
     cutpoint[s]= low + (up-low)*uniform(&seed);
   end;

 * if mcmc<20 then do;
 *   print mcmc cutpoint (lambdainv`);
 * end;

  catcutlow = (-&valmax)||0||cutpoint||(-&valmax);
  catcutup = 0||cutpoint||(&valmax)||(&valmax);
 *** update Z;
 datat2=drawlatent_gibbs(datat2, beta, lambdainv, nposttrt, npatindex, raw2, catcutlow, catcutup,mcmc);

  col = (mcmc -&nburn)/&nthin;

  if (&plotafterburn>0) & (mcmc> &nburn) & (mcmc<=&nburn+&plotafterburn) then do;
    *  if mcmc=&nburn+1 then betaplot=shape(cutpoint,&npost,&ncat-2)|| beta||lambdainv||J(&npost,1,col);
	*  else betaplot=betaplot//(shape(cutpoint,&npost,&ncat-2)||beta||lambdainv||J(&npost,1,col)); 
   ntempplot=mcmc-&nburn;
   betaplot[(ntempplot-1)*(&npost)+(1:(&npost)),]=shape(cutpoint,&npost,&ncat-2)|| beta||lambdainv||J(&npost,1,ntempplot);
  end;

  if (col >0) & (int(col)=col) then do;
   * if col=1 then betaall=shape(cutpoint,&npost,&ncat-2)|| beta||lambdainv||J(&npost,1,col);
   * else betaall=betaall//(shape(cutpoint,&npost,&ncat-2)||beta||lambdainv||J(&npost,1,col)); 
   betaall[(col-1)*(&npost)+(1:&npost),]=shape(cutpoint,&npost,&ncat-2)|| beta||lambdainv||J(&npost,1,col);

  catcutrev=catcutlow[&ncat:1];
   if col=1 then nnmistemp=0;
   do s=1 to &npost;
      if nposttrt[s]< ntot then do;
	       index = (nposttrt[s]+1):ntot;
           datat2[index, &nxcov+s]  =datat2[index,1:(&nxcov+s-1)]*(beta[s,1:(&nxcov+s-1)])`+
                 rannor(j(ntot-nposttrt[s],1,&seed))/sqrt(lambdainv[s]);
      *  do k= nposttrt[s]+1 to ntot;
	  *		datat[k,&nxcov+s]=&ncat+1-(((loc(datat2[k, &nxcov+s]>catcutrev))[1]));
	  *	end;
    
        if col=1 then do;
          nnmistemp=nnmistemp+1;
		  if  nnmistemp=1 then indexmissdrop = (index-1)#ncolraw+&nxcov+s;
		  else indexmissdrop =indexmissdrop||((index-1)#ncolraw+&nxcov+s);
		end;
	   *  datat[index, &nxcov+s]= 1;
       *     do t=2 to &ncat;
       *       datat[index, &nxcov+s]=  datat[index, &nxcov+s]+    (datat2[index, &nxcov+s]>=catcutlow[t]);
	   *		end;
	 end;
   end;
       datat[indexmissdrop]= 1;
       do t=2 to &ncat;
       datat[indexmissdrop]=  datat[indexmissdrop]+    (datat2[indexmissdrop]>=catcutlow[t]);
	   end;


    
    if &nmiss>0 then do;
        if col=1 then do;
         do i=1 to nrow(miss);
            if i=1 then indexmissint = (obs[i]-1)*ncolraw+&nxcov+ indexmiss[i,1: tmiss[i]];
			else indexmissint=indexmissint|| ((obs[i]-1)*ncolraw+&nxcov+ indexmiss[i,1: tmiss[i]]);
		 end;
		end;

      *   do i=1 to nrow(miss);
      *    do k=1 to tmiss[i];
      *    datat[obs[i],&nxcov+ indexmiss[i,k]] =&ncat+1-(((loc(datat2[obs[i],&nxcov+ indexmiss[i,k]]>catcutrev))[1]));
	  *	  end;
      *   end;

        datat[indexmissint]= 1;
        do t=2 to &ncat;
            datat[indexmissint]=  datat[indexmissint]+    (datat2[indexmissint]>=catcutlow[t]);
	    end;
      end;

   * if col=1 then dataall=datat||J(ntot,1,col);
   *	else dataall=dataall//(datat||J(ntot,1,col));
	dataall[(col-1)*ntot+(1:ntot),]=datat|| datat2[, &nxcov+(1:&npost)]||J(ntot,1,col);
  end;
end;


create &betaout from betaall[colname={%do kkk=2 %to %eval(&ncat-1); "cut&kkk" %end;  &colname %do kkk=1 %to %eval(&npost); "y&kkk" %end; 'invsig' 'rep'}];
append from betaall;

create &dataimpout from dataall[colname={&colname %do kkk=1 %to &npost; "y&kkk" %end;'pattern' 'pid' 
        %do kkk=1 %to &npost; "w&kkk" %end;   'rep'}];
append from dataall;


start autocorr(vector,nleng, lage);
  corr1 =j(1+lage,1,0);
  mu = mean(vector);
  vectoradj =vector-mu;
  corr1[1]= (vectoradj##2)[:];
  do lag=1 to lage;
    var11 = (vectoradj[1:(nleng-lag)]#vectoradj[(lag+1):nleng])[+]/nleng;
    corr1[lag+1]= var11 /corr1[1];
  end;
 return(corr1);
finish;

if &plotafterburn>0 then do;

 corrall= j(&nlag+1, &ncat-3+ (&nxcov+1)*(&npost)+ sum(1:(&npost-1)),0);
 tag=0;
 do s=catlowupdate to catupupdate;
   cut = betaplot[ (0:(&plotafterburn-1))*(&npost)+1,s];
   tag=tag+1;
   corrall[,tag]= autocorr(cut,&plotafterburn,&nlag);
 end;
 
 do s=1 to &npost;
   do k=1 to &nxcov+s-1;
     cut = betaplot[ (0:(&plotafterburn-1))*(&npost)+s,&ncat-2 + k];
     tag=tag+1;
     corrall[,tag]= autocorr(cut,&plotafterburn,&nlag);
  end;
  if (&PXDA>=3) | (s^=1) then do; 
     cut = betaplot[ (0:(&plotafterburn-1))*(&npost)+s, &ncat-2 + &nxcov+&npost+1];
     tag=tag+1;
     corrall[,tag]= autocorr(cut,&plotafterburn,&nlag);
	end;
 end;
 

 if &PXDA<3 then do;
  colname1={%do kkk=2 %to %eval(&ncat-1); "cut&kkk" %end;
   %do kkk=1 %to &nxcov; "alpha1_&kkk" %end; 
  %do s=2 %to &npost; %do kkk=1 %to &nxcov; "alpha&s._&kkk" %end; 
     %do kkk=1 %to %eval(&s-1); "beta&s._&kkk" %end;
    "gamma&s" %end; };
  end;
  else if &PXDA=3 then do;
      colname1={%do kkk=2 %to %eval(&ncat-2); "cut&kkk" %end;
   %do kkk=1 %to &nxcov; "alpha1_&kkk" %end; 'gamma1'
   %do s=2 %to &npost; %do kkk=1 %to &nxcov; "alpha&s._&kkk" %end; 
     %do kkk=1 %to %eval(&s-1); "beta&s._&kkk" %end;
    "gamma&s" %end; };
  end;
  else if &PXDA=4 then do;
      colname1={%do kkk=3 %to %eval(&ncat-1); "cut&kkk" %end;
   %do kkk=1 %to &nxcov; "alpha1_&kkk" %end; 'gamma1'
   %do s=2 %to &npost; %do kkk=1 %to &nxcov; "alpha&s._&kkk" %end; 
     %do kkk=1 %to %eval(&s-1); "beta&s._&kkk" %end;
    "gamma&s" %end; };
  end;

 create autocorr from corrall[colname=colname1];
 append from corrall;
end;

quit;
%mend;


%macro MNAR_imputation(dataimpin=dataall, dataimpout=,
     betain=betaall, method=J2R CR DELTAFIR DELTAALL, delta=0.2,nxcov=2, ncat=4, npost=3,colname= );
  
  data _null_;
  set &dataimpin end=eof;
  if eof then do;
      call symput('nsample', rep);
	  call symput('ntot', _N_/rep);
  end;
  run; 

  proc iml;
   use &dataimpin;
   read all into dataall;

   use &betain;
   read all into betaall;
 
  indexdatat2=(1:&nxcov)||(&nxcov+&npost+2+(1:&npost));

   do col=1 to &nsample;
   
	 beta =  betaall[(col-1)*(&npost)+(1:&npost),];
     cutpoint =beta[1,1:(&ncat-2)];
  
     datat = dataall[(col-1)*(&ntot)+(1:&ntot),];

	 if col=1 then do;
	     idenmatrix =I(&npost);
	     pat =datat[, &nxcov+&npost+1];
	     npatactive =j(&npost,1,0);
         locpatactive =j(&npost, &ntot,0); 
		 ncolraw = ncol(datat);
		 tag=0;
		
        do j=1 to &npost;
		  temp= ((pat=(j-1)) & (datat[,&nxcov]=1));
		  npatactive[j] =sum(temp);
		  if npatactive[j]>0 then do;
		     loctemp=loc(temp);
             locpatactive[j, 1: npatactive[j]]=loctemp;
             locpattemp= shape((loctemp-1)*ncolraw, &npost-j+1, npatactive[j])+((j:&npost)`+&nxcov);
			 locpattemp= shape(locpattemp, (&npost-j+1)*npatactive[j],1);
             tag=tag+1;
			 if tag=1 then  indexalldroppos =locpattemp;
		     else indexalldroppos =indexalldroppos //locpattemp;
		  end;
        end;
          indexalldroppos2=indexalldroppos+&npost+2; 
	 end;


	 U = -beta[, &ncat-2 +&nxcov +(1:&npost)];
     L = trisolv(4,U,idenmatrix); ***inverse of U;
   

	if upcase("&method")='J2R' then  effadj = L* beta[,&ncat-2 +&nxcov];
	else if upcase("&method")='DELTAFIR' then do;
       betaadj =j(&npost,1,0); betaadj[1]=&delta;
    end; 
	else if upcase("&method")='DELTAALL' then betaadj =j(&npost,1,&delta);
 

    do j=1 to &npost;
	    if npatactive[j]>0 then do;
	
		 index=locpatactive[j, 1: npatactive[j]];	 
		 index2=(j:&npost);
		 index3=index2+&nxcov+&npost+2;
          *****adjustment for subjects in pattern (j-1) -- active subjects only;
		 
	

        if upcase("&method")='J2R' then 
          datat[index,index3]= datat[index,index3] -(effadj[index2])`; 
		else if upcase("&method")='CR' then
          datat[index,index3]= datat[index,index3] -(L[index2,index2]*beta[index2,&ncat-2 +&nxcov])`; 
        else if upcase("&method")='DELTAALL' then 
          datat[index,index3]= datat[index,index3] -(L[index2,index2]*betaadj[index2])`;
        else if upcase("&method")='DELTAFIR' then 
		    datat[index,index3]= datat[index,index3] -(L[index2,index2]*betaadj[1:(&npost-j+1)])`;
      end;
    end;

       datat[indexalldroppos]= 1+ (datat[indexalldroppos2]>0);
	   do t=1 to &ncat-2;
          datat[indexalldroppos]=datat[indexalldroppos]+(datat[indexalldroppos2]>cutpoint[t]);
	   end;
	

      dataall[(col-1)*(&ntot)+(1:&ntot),]=datat;
   end;
  create &dataimpout from dataall[colname={&colname %do kkk=1 %to &npost; "y&kkk" %end;'pattern' 'pid' 
        %do kkk=1 %to &npost; "w&kkk" %end;   'rep'}];
  append from dataall;
  quit;
%mend;


%macro logistic_visit(dataimpin=dataall,cov=trt, cov2=intercept trt, vis=p,resulttemp=oookkk,ntot=431, missing=MAR, model=probit);
 ods listing close;
 PROC logistic  data= &dataimpin;
   MODEL  y&vis =  &cov;
   by rep;
   ods output ParameterEstimates=parmi(rename=(rep=_imputation_));
 RUN;
  ods listing;

 proc mianalyze parms(classvar=full)=parmi edf=&ntot;
  modeleffects &cov2;
  ods output ParameterEstimates= &resulttemp  VarianceInfo=temptemptemp2;
  title "MI analysis summary: &model, &missing, visit &vis"; 
 run;


 data &resulttemp;
 retain model missing visit;
 length missing $10.;
 merge &resulttemp temptemptemp2;
 model="&model";
 missing="&missing";
 visit=&vis;
 run;

%mend;

%macro logis_data_analysis (dataimpin=dataall,nsample=400,
   cov=trt, cov2=intercept trt, ncat=4, npost=3, visit=last, resultout=miest, missing=MAR, model=PROBIT);
 
data _null_;
retain aaa 0;
set &dataimpin;
by rep;
aaa=aaa+1;
if rep=1;
if last.rep then call symput('ntot', aaa);
run;
%put 'ntot' &ntot;

%if %upcase(&visit)=LAST %then %do;
 %logistic_visit(dataimpin=&dataimpin, cov=&cov, cov2=&cov2, vis=&npost,resulttemp=&resultout,ntot=&ntot, missing=&missing, model=&model);
%end;
%else %do;
 %do kkk=1 %to &npost;
  %logistic_visit(dataimpin=&dataimpin, cov=&cov, cov2=&cov2, vis=&kkk,resulttemp=resulttemp,ntot=&ntot, missing=&missing, model=&model);
   %if &kkk=1 %then %do;
      data &resultout;set resulttemp; run;       
   %end;
   %else %do;
      proc append base=&resultout data=resulttemp force;run;
   %end;

 %end;
%end;

%mend;



%macro gee_data_analysis (dataimpin=dataall,nsample=400, cov=trt, ncat=4, npost=3, method=GEE, GEEcorr=IND, resultout=miest);
 
data _null_;
retain aaa 0;
set &dataimpin;
by rep;
aaa=aaa+1;
if rep=1;
if last.rep then call symput('ntot', aaa);
run;
%put 'ntot' &ntot;


%if %index(%upcase(&method),GEE)>0 %then %do;
 data datatemp;
 array yy{&npost} y1-y&npost;
 set &dataimpin;
 by rep descending pattern descending trt pid;
 do vis=1 to &npost;
      y= yy[vis]; output;
 end;
 run;
  
ods listing close;
proc genmod data=datatemp;
class  pid vis trt;
 MODEL  y= vis*trt/noint  dist=multinomial
                         link=cumlogit;
   repeated subject=pid / type=&geecorr PRINTMLE;
   estimate 'trtvis' vis*trt %do kkk=1 %to %eval(&npost-1); 0 0 %end; -1 1;
   by rep;  
 ods output ParameterEstimates= parmgeei (rename=(rep=_imputation_)) estimates=estgeei;
 RUN;
ods listing;

data estgeei;
set estgeei;
rename label=parameter rep=_imputation_ lbetaestimate=estimate;
run;

 proc mianalyze parms(classvar=full)=estgeei;
  class  visit ;
  modeleffects trtvis;
  ods output ParameterEstimates= resmi;
 run;
%end;

%if %index(%upcase(&method),LOGIS)>0 %then %do;
 ods listing close;
 PROC logistic  data= &dataimpin;
   MODEL  y&npost =  &cov;
   by rep;
   ods output ParameterEstimates=parmi(rename=(rep=_imputation_));
 RUN;
 ods listing;
 proc mianalyze parms(classvar=full)=parmi edf=&ntot;
  modeleffects &cov;
  ods output ParameterEstimates= resmi;
 run;
%end;

%mend;

